/* Type information for config/bpf/btfext-out.cc.
   Copyright (C) 2004-2024 Free Software Foundation, Inc.

This file is part of GCC.

GCC is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 3, or (at your option) any later
version.

GCC is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING3.  If not see
<http://www.gnu.org/licenses/>.  */

/* This file is machine generated.  Do not edit.  */

void
gt_ggc_mx_btf_ext_funcinfo (void *x_p)
{
  struct btf_ext_funcinfo * x = (struct btf_ext_funcinfo *)x_p;
  struct btf_ext_funcinfo * xlimit = x;
  while (ggc_test_and_set_mark (xlimit))
   xlimit = ((*xlimit).next);
  while (x != xlimit)
    {
      gt_ggc_m_S ((*x).fnname);
      gt_ggc_m_S ((*x).label);
      gt_ggc_m_16btf_ext_funcinfo ((*x).next);
      x = ((*x).next);
    }
}

void
gt_ggc_mx_btf_ext_lineinfo (void *x_p)
{
  struct btf_ext_lineinfo * x = (struct btf_ext_lineinfo *)x_p;
  struct btf_ext_lineinfo * xlimit = x;
  while (ggc_test_and_set_mark (xlimit))
   xlimit = ((*xlimit).next);
  while (x != xlimit)
    {
      gt_ggc_m_16btf_ext_lineinfo ((*x).next);
      x = ((*x).next);
    }
}

void
gt_ggc_mx_btf_ext_core_reloc (void *x_p)
{
  struct btf_ext_core_reloc * x = (struct btf_ext_core_reloc *)x_p;
  struct btf_ext_core_reloc * xlimit = x;
  while (ggc_test_and_set_mark (xlimit))
   xlimit = ((*xlimit).next);
  while (x != xlimit)
    {
      gt_ggc_m_7rtx_def ((*x).bpfcr_insn_label);
      gt_ggc_m_S ((*x).info.accessor_str);
      gt_ggc_m_9tree_node ((*x).info.type);
      gt_ggc_m_18btf_ext_core_reloc ((*x).next);
      x = ((*x).next);
    }
}

void
gt_ggc_mx_btf_ext_info_sec (void *x_p)
{
  struct btf_ext_info_sec * x = (struct btf_ext_info_sec *)x_p;
  struct btf_ext_info_sec * xlimit = x;
  while (ggc_test_and_set_mark (xlimit))
   xlimit = ((*xlimit).next);
  while (x != xlimit)
    {
      gt_ggc_m_S ((*x).sec_name);
      gt_ggc_m_16btf_ext_funcinfo ((*x).func_info.head);
      gt_ggc_m_16btf_ext_lineinfo ((*x).line_info.head);
      gt_ggc_m_18btf_ext_core_reloc ((*x).core_info.head);
      gt_ggc_m_16btf_ext_info_sec ((*x).next);
      x = ((*x).next);
    }
}

void
gt_ggc_mx_string_cache (void *x_p)
{
  struct string_cache * x = (struct string_cache *)x_p;
  struct string_cache * xlimit = x;
  while (ggc_test_and_set_mark (xlimit))
   xlimit = ((*xlimit).next);
  while (x != xlimit)
    {
      gt_ggc_m_S ((*x).str);
      gt_ggc_m_12string_cache ((*x).next);
      x = ((*x).next);
    }
}

void
gt_pch_nx_btf_ext_funcinfo (void *x_p)
{
  struct btf_ext_funcinfo * x = (struct btf_ext_funcinfo *)x_p;
  struct btf_ext_funcinfo * xlimit = x;
  while (gt_pch_note_object (xlimit, xlimit, gt_pch_p_16btf_ext_funcinfo))
   xlimit = ((*xlimit).next);
  while (x != xlimit)
    {
      gt_pch_n_S ((*x).fnname);
      gt_pch_n_S ((*x).label);
      gt_pch_n_16btf_ext_funcinfo ((*x).next);
      x = ((*x).next);
    }
}

void
gt_pch_nx_btf_ext_lineinfo (void *x_p)
{
  struct btf_ext_lineinfo * x = (struct btf_ext_lineinfo *)x_p;
  struct btf_ext_lineinfo * xlimit = x;
  while (gt_pch_note_object (xlimit, xlimit, gt_pch_p_16btf_ext_lineinfo))
   xlimit = ((*xlimit).next);
  while (x != xlimit)
    {
      gt_pch_n_16btf_ext_lineinfo ((*x).next);
      x = ((*x).next);
    }
}

void
gt_pch_nx_btf_ext_core_reloc (void *x_p)
{
  struct btf_ext_core_reloc * x = (struct btf_ext_core_reloc *)x_p;
  struct btf_ext_core_reloc * xlimit = x;
  while (gt_pch_note_object (xlimit, xlimit, gt_pch_p_18btf_ext_core_reloc))
   xlimit = ((*xlimit).next);
  while (x != xlimit)
    {
      gt_pch_n_7rtx_def ((*x).bpfcr_insn_label);
      gt_pch_n_S ((*x).info.accessor_str);
      gt_pch_n_9tree_node ((*x).info.type);
      gt_pch_n_18btf_ext_core_reloc ((*x).next);
      x = ((*x).next);
    }
}

void
gt_pch_nx_btf_ext_info_sec (void *x_p)
{
  struct btf_ext_info_sec * x = (struct btf_ext_info_sec *)x_p;
  struct btf_ext_info_sec * xlimit = x;
  while (gt_pch_note_object (xlimit, xlimit, gt_pch_p_16btf_ext_info_sec))
   xlimit = ((*xlimit).next);
  while (x != xlimit)
    {
      gt_pch_n_S ((*x).sec_name);
      gt_pch_n_16btf_ext_funcinfo ((*x).func_info.head);
      gt_pch_n_16btf_ext_lineinfo ((*x).line_info.head);
      gt_pch_n_18btf_ext_core_reloc ((*x).core_info.head);
      gt_pch_n_16btf_ext_info_sec ((*x).next);
      x = ((*x).next);
    }
}

void
gt_pch_nx_string_cache (void *x_p)
{
  struct string_cache * x = (struct string_cache *)x_p;
  struct string_cache * xlimit = x;
  while (gt_pch_note_object (xlimit, xlimit, gt_pch_p_12string_cache))
   xlimit = ((*xlimit).next);
  while (x != xlimit)
    {
      gt_pch_n_S ((*x).str);
      gt_pch_n_12string_cache ((*x).next);
      x = ((*x).next);
    }
}

void
gt_pch_p_16btf_ext_funcinfo (ATTRIBUTE_UNUSED void *this_obj,
	void *x_p,
	ATTRIBUTE_UNUSED gt_pointer_operator op,
	ATTRIBUTE_UNUSED void *cookie)
{
  struct btf_ext_funcinfo * x ATTRIBUTE_UNUSED = (struct btf_ext_funcinfo *)x_p;
  if ((void *)(x) == this_obj)
    op (&((*x).fnname), NULL, cookie);
  if ((void *)(x) == this_obj)
    op (&((*x).label), NULL, cookie);
  if ((void *)(x) == this_obj)
    op (&((*x).next), NULL, cookie);
}

void
gt_pch_p_16btf_ext_lineinfo (ATTRIBUTE_UNUSED void *this_obj,
	void *x_p,
	ATTRIBUTE_UNUSED gt_pointer_operator op,
	ATTRIBUTE_UNUSED void *cookie)
{
  struct btf_ext_lineinfo * x ATTRIBUTE_UNUSED = (struct btf_ext_lineinfo *)x_p;
  if ((void *)(x) == this_obj)
    op (&((*x).next), NULL, cookie);
}

void
gt_pch_p_18btf_ext_core_reloc (ATTRIBUTE_UNUSED void *this_obj,
	void *x_p,
	ATTRIBUTE_UNUSED gt_pointer_operator op,
	ATTRIBUTE_UNUSED void *cookie)
{
  struct btf_ext_core_reloc * x ATTRIBUTE_UNUSED = (struct btf_ext_core_reloc *)x_p;
  if ((void *)(x) == this_obj)
    op (&((*x).bpfcr_insn_label), NULL, cookie);
  if ((void *)(x) == this_obj)
    op (&((*x).info.accessor_str), NULL, cookie);
  if ((void *)(x) == this_obj)
    op (&((*x).info.type), NULL, cookie);
  if ((void *)(x) == this_obj)
    op (&((*x).next), NULL, cookie);
}

void
gt_pch_p_16btf_ext_info_sec (ATTRIBUTE_UNUSED void *this_obj,
	void *x_p,
	ATTRIBUTE_UNUSED gt_pointer_operator op,
	ATTRIBUTE_UNUSED void *cookie)
{
  struct btf_ext_info_sec * x ATTRIBUTE_UNUSED = (struct btf_ext_info_sec *)x_p;
  if ((void *)(x) == this_obj)
    op (&((*x).sec_name), NULL, cookie);
  if ((void *)(x) == this_obj)
    op (&((*x).func_info.head), NULL, cookie);
  if ((void *)(x) == this_obj)
    op (&((*x).line_info.head), NULL, cookie);
  if ((void *)(x) == this_obj)
    op (&((*x).core_info.head), NULL, cookie);
  if ((void *)(x) == this_obj)
    op (&((*x).next), NULL, cookie);
}

void
gt_pch_p_12string_cache (ATTRIBUTE_UNUSED void *this_obj,
	void *x_p,
	ATTRIBUTE_UNUSED gt_pointer_operator op,
	ATTRIBUTE_UNUSED void *cookie)
{
  struct string_cache * x ATTRIBUTE_UNUSED = (struct string_cache *)x_p;
  if ((void *)(x) == this_obj)
    op (&((*x).str), NULL, cookie);
  if ((void *)(x) == this_obj)
    op (&((*x).next), NULL, cookie);
}

/* GC roots.  */

EXPORTED_CONST struct ggc_root_tab gt_ggc_r_gt_btfext_out_h[] = {
  {
    &btf_ext_strings,
    1,
    sizeof (btf_ext_strings),
    &gt_ggc_mx_string_cache,
    &gt_pch_nx_string_cache
  },
  {
    &btf_ext,
    1,
    sizeof (btf_ext),
    &gt_ggc_mx_btf_ext_info_sec,
    &gt_pch_nx_btf_ext_info_sec
  },
  {
    &btf_ext_info_section,
    1,
    sizeof (btf_ext_info_section),
    &gt_ggc_mx_section,
    &gt_pch_nx_section
  },
  LAST_GGC_ROOT_TAB
};

